Subject: Re: bug#34338: 26.1; delete-file return codes and failures

From: Eli Zaretskii <[email-masked]>
Date: Thu, 07 Feb 2019 05:36:00 +0200

> Date: Wed, 6 Feb 2019 16:02:11 -0500
> From: Boruch Baum <[email-masked]>
> Cc: [email-masked]
> 
> > > B2) raise an error when (not NOERROR) and:
> > >
> > >   B2.1) file doesn't exist
> > >
> > >   B2.2) (and (chmod -w) (not FORCE))
> > >
> > >   B2.3) another form of permission denial is encountered
> >
> > !ERROR and either of the following, or all of them?
> 
> Either.
> 
> > In any case, you propose a backward-incompatible change in behavior,
> > so it won't fly. We could perhaps do it the other way around: add a
> > new optional argument ERROR-OUT, which, when non-nil, will cause the
> > function to signal an error when B2.1 or B2.2 happen (I believe B2.3
> > already causes an error). And similarly with FORCE.
> 
> > IOW
> > ... (snip) ...
> 
> The part that would transform a prior condition of 'crash' to some
> return value is a kind of backward-incompatibility that I think most
> people would appreciate.

I'm more worried about the opposite: signaling an error where we
currently silently do nothing.

> For a proposed FORCE arg, backward-incompatibility is a positive
> feature, a bug-fix

Sorry, it's too late to fix such "bugs" in veteran interfaces.  We
must do that in backward-compatible way.

> > > C) maybe log the exact error or reason for nil to *Messages*.
> >
> > Not sure what you mean by "exact error or reason", I believe we
> > already log the reason.
> 
> For me, in response chmod -x $parent_dir, the error message is:
> 
>   eval: Removing old name: Permission denied, /home/boruch/foo/bar
> 
> And the response to chattr +i bar
> 
>   eval: Removing old name: Operation not permitted, /home/boruch/foo/bar
> 
> So the messages are unique, but not clear.

The description comes from the error code returned by a C library
function.  Doing more than that would mean additional checks, which
will be expensive and probably non-portable.  I don't see the benefit.
I mean, why isn't "Operation not permitted" enough, it tells you that
your user is not permitted to do that, which is clear enough IMO.